program BC;


DEVICE = mega1284P;



CONST

  // BAUDRATE  = 81920;
  // ProcClock = 16384000;       {Hertz}
  // ((ProcClock+BAUDRATE*8)/(BAUDRATE*16)-1)
  // (((81920*8)+16384000)/(81920*16))-1) = ((655360+16384000)/1310720)-1 =
  // (17039360/1310720)-1 = 13-1 = 12
  UBRR_VAL : WORD = 12;

  XON  : Byte = $11;
  XOFF : Byte = $13;




{--------------------------------------------------------------}


var

{
UDR1, UBRR1H, UBRR1L, UCSR1C, UCSR1B, UCSR1A
UDR0, UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A
TWAM, TWCR, TWDR, TWAR, TWSR, TWBR, 
ASSR, OCR2B, OCR2A, OCR2, 
TCNT2, TCCR2, TCCR2B, TCCR2A,
OCR1BH, OCR1BL, OCR1AH, OCR1AL,
ICR1H, ICR1L, 
TCNT1H, TCNT1L, TCCR1C, TCCR1B, TCCR1A
DIDR1, DIDR0,
ADMUX, ADCSRB, ADCSR, ADCSRA, ADCH, ADCL
PCMSK3, 
TIMSK2, TIMSK1, TIMSK0,
PCMSK2, PCMSK1, PCMSK0,
EICRA, PCICR, OSCCAL,
PRR, PRR0,
CLKPR, WDTCR, WDTCSR,
SREG, SPH, SPL, RAMPZ,
SPMCSR, SPMCR, MCUCR, MCUCSR, MCUSR, SMCR,
OCDR, ACSR, SPDR, SPDR0, SPSR, SPSR0, SPCR, SPCR0,
GPIOR2, GPIOR1, 
OCR0B, OCR0, OCR0A,
TCNT0, TCCR0B, TCCR0, TCCR0A,
GTCCR, 
EEARH, EEARL, EEDR, EECR,
GPIOR0,
EIMSK, EIFR, PCIFR,
TIFR2, TIFR1, TIFR0,
}

  PORTD, DDRD, PIND, PORTC, DDRC, PINC, 
  PORTB, DDRB, PINB, PORTA, DDRA, PINA : ByteConReg; 

  UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A, UDR0 : ByteConVar;
  UBRR0 : WordConVar;


  RXC0[UCSR0A,7] : Bit;
  TXC0[UCSR0A,6] : Bit;
  UDRE0[UCSR0A,5] : Bit;

{
PC0 = /M1      A -> H
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}
  M1_A   [PortC,0] : bit;
  M1_E   [PINC, 0] : bit;
  M1_D   [DDRC, 0] : bit;

  MREQ_A [PortC,1] : bit;
  MREQ_E [PINC, 1] : bit;
  MREQ_D [DDRC, 1] : bit;

  IORQ_A [PortC,2] : bit;
  IORQ_E [PINC, 2] : bit;
  IORQ_D [DDRC, 2] : bit;

  RD_A   [PortC,3] : bit;
  RD_E   [PINC, 3] : bit;
  RD_D   [DDRC, 3] : bit;

  WR_A   [PortC,4] : bit;
  WR_E   [PINC, 4] : bit;
  WR_D   [DDRC, 4] : bit;

  RESET_A[PortC,5] : bit;
  RESET_E[PINC, 5] : bit;
  RESET_D[DDRC, 5] : bit;

  BUSRQ_A[PortC,6] : bit;
  BUSRQ_E[PINC, 6] : bit;
  BUSRQ_D[DDRC, 6] : bit;

  BUSAK_A[PortC,7] : bit;
  BUSAK_E[PINC, 7] : bit;
  BUSAK_D[DDRC, 7] : bit;

{
PD0 = RXD0 E <-
PD1 = TXD0 A ->
PD2 = /CSAE    A -> H
PD3 = /INCRQ   E <- X
PD4 = /Z80CALL E <- X
PD5 = /Z80AK   A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}

  RXD0_E [PIND, 0] : bit;
  TXD0_A [PortD,1] : bit;
  CSAE_A [PortD,2] : bit;
  INCRQ_E [PIND,3] : bit;
  Z80CALL_E[PIND,4]: bit;
  Z80AK_A[PortD,5] : bit;
  LED_GRUEN[PortD,6]: bit;
  LED_ROT[PortD,7] : bit;

  LED_ON : Boolean;

  Zeichen : Byte;



{--------------------------------------------------------------}
{ functions }


procedure InitPorts;
begin
  // PORT A = Daten
  DDRA:=  %00000000;

  // PORT B = SPI-Programmierung
  DDRB:=  %00000000;

{
PC0 = /M1      A -> H
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}
  //       EAAAAAAA
  DDRC:=  %00000000;

{
PD0 = RXD0      E <-
PD1 = TXD0      A ->
PD2 = /CSAE     A -> H
PD3 = /INCRQ    E <- X
PD4 = /Z80CALL  E <- X
PD5 = /Z80AK    A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}
  //       AAAEEAAE
  DDRD:=  %11000010;

end InitPorts;






procedure INIT_SER_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0 := UBRR_VAL;

{
Bit 4 – RXEN: Receiver Enable
Das Setzen dieses Bits auf 1 gibt den USART Empfänger frei. Der Empfänger überschreibt die normale Portfunktion des RxD Pins, wenn er freigegeben ist. Das Sperren des Empfängers löscht den Empfängerbuffer und macht die FE, DOR und PE Flags ungültig. 

Bit 3 – TXEN: Transmitter Enable
Das Setzen dieses Bits gibt den USART Sender frei. Der Sender überschreibt die normale Portfunktion des TxD Pins, wenn er freigegeben ist. Das Sperren des Senders (TXEN auf 0 setzen) wird erst wirksam, wenn laufende und wartende Übertragungen abgeschlossen sind, d.h. wenn das Senderschieberegister und der Senderbuffer keine noch zu übertragenden Daten mehr enthalten. Nach dem Sperren wird der TxD Port nicht meht überschrieben. 
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER_PORT;







// ******************************
// *** serielle Schnittstelle ***
// ******************************


procedure sende_Zeichen(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0  
  while BitLow(UDRE0) do
    SetBit(LED_GRUEN); // gruen ein
  endwhile;

  ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen;

end sende_Zeichen; 



procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt 
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    Zeichen:=UDR0;
 //   CONOUT;
    sende_Zeichen(XON);
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;









PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 720 do // 45 * MHz
    endfor;
  endfor;
END wait_ms;





{--------------------------------------------------------------}
{ Main Program }
{$IDATA}







begin

ASM;

.equ UBRR0 = UBRR0L

ENDASM;

  InitPorts;

  INIT_SER_PORT;

  ClearBit(LED_GRUEN);  // LED_GRUEN aus
  SetBit(LED_ROT);  // LED_ROT aus
  LED_ON:=false;


  loop


    if LED_ON then
      ClearBit(LED_GRUEN);
      SetBit(LED_ROT);
      LED_ON:=false;
    else
      SetBit(LED_GRUEN);
      ClearBit(LED_ROT);
      LED_ON:=true;
    endif;

    wait_ms(500);

  endloop;







end BC.


